/* Kill unstoppable Samba daemons using RXU kill feature */
'@echo off'
say "Ultimate Samba killer"
signal on syntax name Errorhandler

parms = translate(arg(1))
Quiet = (pos('-Q',parms) > 0)

/* You will need rxu.DLL somewhere in your LIBPATH */
call rxfuncadd 'rxuinit','rxu','rxuinit'
call rxuinit

ok = SysFileTree(value('ETC',,'OS2ENVIRONMENT')'\samba\pid\*.pid',pidfiles.,'FO')
if \Quiet then say "Step 1: Read remaining pid files and terminate pids found there."
if pidfiles.0 = 0 then do
    if \Quiet then say '- No more pid files found.'
end
else do
    if \Quiet then say '- 'pidfiles.0' pid files found. '
    do I = 1 to pidfiles.0
        PidLine = linein(Pidfiles.I)
        decpid = PidLine+0
        ok = stream(PidFiles.I,'c','close')
        if \Quiet then say '- Found 'filespec('N',pidfiles.I)'. '
        if \Quiet then call charout , '- Attempting to kill 'decpid', result "'
        killrc = RxKillProcess(decPid)
        if \Quiet then say KillRC'".'
        if \Quiet then say '- Erase 'Pidfiles.I
        ok = SysFileDelete(Pidfiles.I)
        ok = SysSleep(0.2)
    end
end 

if \Quiet then say "Step 2: Test if Samba daemons are still running."
rc = rxqprocstatus('q.','l')
foundSamba = 0
do j=1 to q.0p.0
    Process = filespec('N',q.0p.j.6)
    if Process = "SMBD.EXE" | Process = "NMBD.EXE" | Process = "WINBINDD.EXE" then do
        foundSamba = 1
        if \Quiet then call charout , '- 'filespec('N',q.0p.j.6)' pid = 'q.0p.j.1' running, kill result "'
        decPid = x2d(q.0p.j.1)
        killrc = RxKillProcess(decpid)
        if \Quiet then say KillRC'".'
        ok = SysSleep(0.2)
    end
end
if \foundSamba then say "- No more Samba daemons running."
else do
    if \Quiet then say "Step 3: Test if Samba kill attempts were successful."
    rc = rxqprocstatus('q.','l')
    KillSamba = 0

    do j=1 to q.0p.0
        Process = filespec('N',q.0p.j.6)
        if Process = "SMBD.EXE" | Process = "NMBD.EXE" | Process = "WINBINDD.EXE" then do
            KillSamba = KillSamba + 1
            if \Quiet then call charout , '- 'filespec('N',q.0p.j.6)' pid = 'q.0p.j.1' still running, kill result "'
            decPid = x2d(q.0p.j.1)
            killrc = RxKillProcess(decpid)
            if \Quiet then say KillRC'".'
            ok = SysSleep(0.2)
        end
    end
    say "- "KillSamba" attempts to kill reminaing Samba daemons."
end
exit 0

Errorhandler:
    say "killpid terminated - error in line "sigl
    say '"'sourceline(sigl)'" failed.'
exit 255

